var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Action = function () {
    _createClass(Action, null, [{
        key: 'Stage',
        get: function get() {
            return {
                STARTED: 'started',
                SUCCESS: 'success',
                ERROR: 'error'
            };
        }
    }]);

    function Action(type) {
        _classCallCheck(this, Action);

        this.baseType = type;
    }

    Action.prototype.type = function type(stage) {
        return this.baseType + (stage ? '.' + stage : '');
    };

    Action.prototype.typeStarted = function typeStarted() {
        return this.type(Action.Stage.STARTED);
    };

    Action.prototype.typeSuccess = function typeSuccess() {
        return this.type(Action.Stage.SUCCESS);
    };

    Action.prototype.typeError = function typeError() {
        return this.type(Action.Stage.ERROR);
    };

    Action.prototype.action = function action() {
        var stage = arguments[0],
            payload = arguments[1],
            error = arguments[2];

        if (arguments.length === 1) {
            stage = undefined;
            payload = arguments[0];
        }

        return {
            type: this.type(stage),
            error: error,
            payload: payload
        };
    };

    Action.prototype.started = function started(payload) {
        return this.action(Action.Stage.STARTED, payload);
    };

    Action.prototype.success = function success(payload) {
        return this.action(Action.Stage.SUCCESS, payload);
    };

    Action.prototype.error = function error(payload) {
        return this.action(Action.Stage.ERROR, payload, true);
    };

    Action.prototype.on = function on() {
        var stage = arguments[0],
            handler = arguments[1];
        if (arguments.length === 1) {
            stage = undefined;
            handler = arguments[0];
        }

        return Object.assign(handler, { type: this.type(stage) });
    };

    Action.prototype.onStarted = function onStarted(handler) {
        return this.on(Action.Stage.STARTED, handler);
    };

    Action.prototype.onSuccess = function onSuccess(handler) {
        return this.on(Action.Stage.SUCCESS, handler);
    };

    Action.prototype.onError = function onError(handler) {
        return this.on(Action.Stage.ERROR, handler);
    };

    Action.initial = function initial(functionOrState) {
        if (typeof functionOrState === "function") {
            return Object.assign(functionOrState, { initial: true });
        } else {
            return Object.assign(function () {
                return functionOrState;
            }, { initial: true });
        }
    };

    Action.createReducer = function createReducer() {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        var actionHandlers = args,
            key;
        if (typeof args[0] === "string") {
            key = args[0];
            actionHandlers = args.slice(1);
        }

        actionHandlers = actionHandlers.filter(function (h) {
            return !h.initial;
        });
        var initializer = actionHandlers.filter(function (h) {
            return h.initial;
        })[0];

        return function (state, action, fullState) {
            var parentState = void 0;
            if (key) {
                parentState = state;
                state = state[key];
            }

            if (!state) {
                state = initializer ? initializer() : {};
            } else {
                actionHandlers.forEach(function (actionHandler) {
                    if (action.type === actionHandler.type || actionHandler.type === undefined) {
                        var newState = actionHandler(state, actionHandler.type === undefined ? action : action.payload, fullState);
                        if (newState !== undefined) {
                            state = newState;
                        }
                    }
                });
            }

            if (parentState) {
                var _Object$assign;

                return Object.assign({}, parentState, (_Object$assign = {}, _Object$assign[key] = state, _Object$assign));
            } else {
                return state;
            }
        };
    };

    return Action;
}();

export { Action as default };