function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import Action from './Action';

var SimpleOperation = function () {
    function SimpleOperation(mainAction) {
        _classCallCheck(this, SimpleOperation);

        this.mainAction = mainAction;
    }

    SimpleOperation.prototype.createReducer = function createReducer() {
        var mainAction = this.mainAction;


        return Action.createReducer(mainAction.onStarted(function (state, action) {
            var _Object$assign;

            return Object.assign({}, state, (_Object$assign = {}, _Object$assign[action.key] = {
                isProcessing: true
            }, _Object$assign));
        }), mainAction.onSuccess(function (state, action) {
            var _Object$assign2;

            return Object.assign({}, state, (_Object$assign2 = {}, _Object$assign2[action.key] = {
                isProcessing: false,
                wasCompleted: true
            }, _Object$assign2));
        }), mainAction.onError(function (state, action) {
            var _Object$assign3;

            return Object.assign({}, state, (_Object$assign3 = {}, _Object$assign3[action.key] = {
                isProcessing: false,
                error: action.error
            }, _Object$assign3));
        }));
    };

    SimpleOperation.prototype.isProcessing = function isProcessing(key, state) {
        return state[key] ? state[key].isProcessing : false;
    };

    SimpleOperation.prototype.wasCompleted = function wasCompleted(key, state) {
        return state[key] ? state[key].wasCompleted : false;
    };

    SimpleOperation.prototype.processingError = function processingError(key, state) {
        return state[key] ? state[key].error : false;
    };

    SimpleOperation.prototype.mapStateToProps = function mapStateToProps(state, key) {
        var _this = this;

        return key ? {
            isProcessing: this.isProcessing(key, state),
            wasCompleted: this.wasCompleted(key, state),
            processingError: this.processingError(key, state)
        } : {
            isProcessing: function isProcessing(aKey) {
                return _this.isProcessing(aKey, state);
            },
            wasCompleted: function wasCompleted(aKey) {
                return _this.wasCompleted(aKey, state);
            },
            processingError: function processingError(aKey) {
                return _this.processingError(aKey, state);
            }
        };
    };

    SimpleOperation.prototype.started = function started(payload) {
        return this.mainAction.started(payload);
    };

    SimpleOperation.prototype.success = function success(payload) {
        return this.mainAction.success(payload);
    };

    SimpleOperation.prototype.error = function error(payload) {
        return this.mainAction.error(payload);
    };

    return SimpleOperation;
}();

export { SimpleOperation as default };